<?php

class EService_Payment_PaymentController extends Mage_Core_Controller_Front_Action {

   


    public function getPayment() {
        return Mage::getSingleton('eservice/payment');
    }

    //redirect the website to the Gateway
    public function redirectAction() {
        if(!isset($_SERVER["HTTP_REFERER"])){
            $url = Mage::getUrl('checkout/onepage/');//if the link was visited directly ,then redirect to checkout page
            $response = Mage::app()->getFrontController()->getResponse();
            $response->setRedirect($url);
            $response->sendResponse();
        }
        $this->getResponse()->setBody($this->getLayout()->createBlock('eservice_payment/redirect')->toHtml());
    }
    public function iframeAction(){
        if(!isset($_SERVER["HTTP_REFERER"])){
            $url = Mage::getUrl('checkout/onepage/');//if the link was visited directly ,then redirect to checkout page
            $response = Mage::app()->getFrontController()->getResponse();
            $response->setRedirect($url);
            $response->sendResponse();
        }
         $this->loadLayout();
         $this->renderLayout();
    }
	
   
	//Gateway send back the callback notification when the payment complete
    public function callbackAction() {
        $requestData = $this->getRequest()->getParams();
        $model = Mage::getModel ( 'eservice_payment/payment' );
        $model->logData('Gateway calling back: '.json_encode($requestData));
        if(empty($requestData) || !isset($requestData['orderid'])  ||  !isset($requestData['merchantTxId']) ){
            return false;
        }
        if($requestData['action'] != 'AUTH' && $requestData['action'] != 'PURCHASE'){
            return false;
        }
        $model->generateCheckStatusRequest($requestData['orderid'],$requestData['merchantTxId']);
	}
	
	//When the order complete, the website will be redirected here to process
	public function responseAction() { 
	    $requestData = $this->getRequest()->getParams();
	    if(empty($requestData) || !isset($requestData['orderid']) || !isset($requestData['result']) ||  !isset($requestData['merchantTxId']) ){
	        header("location:".Mage::getUrl());
	    }
	    
	    $model = Mage::getModel ( 'eservice_payment/payment' );
	    $result = $model->generateCheckStatusRequest($requestData['orderid'],$requestData['merchantTxId']);
	    $session = Mage::getSingleton('checkout/session');
	    $session->unsQuoteId();
	    if($result){
	        $url = Mage::getUrl('checkout/onepage/success/');//redirect to success page
	        $response = Mage::app()->getFrontController()->getResponse();
	        $response->setRedirect($url);
	        $response->sendResponse();
	    }else{
	        $url = Mage::getUrl('checkout/onepage/failure/');//redirect to failure page
	        $response = Mage::app()->getFrontController()->getResponse();
	        $response->setRedirect($url);
	        $response->sendResponse();
	    }
    }
 
    
}

?>